/**
 * @file accessor.cpp
 * @brief LL GLTF Implementation
 *
 * $LicenseInfo:firstyear=2024&license=viewerlgpl$
 * Second Life Viewer Source Code
 * Copyright (C) 2024, Linden Research, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License only.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Linden Research, Inc., 945 Battery Street, San Francisco, CA  94111  USA
 * $/LicenseInfo$
 */

#include "../llviewerprecompiledheaders.h"

#include "asset.h"

using namespace LL::GLTF;

const Buffer& Buffer::operator=(const tinygltf::Buffer& src)
{
    mData = src.data;
    mName = src.name;
    mUri = src.uri;
    return *this;
}

const BufferView& BufferView::operator=(const tinygltf::BufferView& src)
{
    mBuffer = src.buffer;
    mByteLength = src.byteLength;
    mByteOffset = src.byteOffset;
    mByteStride = src.byteStride;
    mTarget = src.target;
    mName = src.name;
    return *this;
}

const Accessor& Accessor::operator=(const tinygltf::Accessor& src)
{
    mBufferView = src.bufferView;
    mByteOffset = src.byteOffset;
    mComponentType = src.componentType;
    mCount = src.count;
    mType = src.type;
    mNormalized = src.normalized;
    mName = src.name;
    mMax = src.maxValues;
    mMin = src.minValues;

    return *this;
}

